<template src="./search.htm"></template>

<script>

    export default {

        mounted() {

            this.getParamsFromUrl();
            this.products.nextPageUrl = this.nextPageUrl;
        },

        props: ['baseUrl', 'nextPageUrl'],

        data() {

            return {

                loading: false,
                products: {
                    data: [],
                    nextPageUrl: '',
                },
                showInitialProducts: true,
                currentSort: null,
                search: {
                    price: null,
                    term: '',
                    dir: null,
                    order: null,
                    brands: [],
                    subCategories: []
                },
                term: '',
                termTimeout: null,
                price: 1,
                priceTimeout: null
            }
        },

        methods: {

            route(url, params) {

                window.location = route(url, params);
            },

            /**
             * @param src
             * @return {*}
             */
            imageCacheRoute(src) {

                return route('images.cache', { template: 'medium', filename: src });
            },


            /**
             * @param product
             */
            productRoute(product) {

                return route('client.product', { slug: product.slug, product: product.id });
            },


            /**
             * Parse params from url on init.
             */
            getParamsFromUrl() {

                let params = parseUrlParams();

                this.search.price               = typeof params.price           !== 'undefined' ? params.price : null;
                this.search.term                = typeof params.term            !== 'undefined' ? params.term : '';
                this.search.dir                 = typeof params.dir             !== 'undefined' ? params.dir : '';
                this.search.order               = typeof params.order           !== 'undefined' ? params.order : '';
                this.search.brands              = typeof params.brands          !== 'undefined' ? params.brands.split(',') : [];
                this.search.subCategories       = typeof params.subCategories   !== 'undefined' ? params.subCategories.split(',') : [];

                if (this.search.order !== '') {

                    this.currentSort = this.currentSort +
                        ' '
                        + (this.search.order == 'price' ?
                            ('Ceni' + ' ' + (this.search.dir == 'asc' ? '(rastuce)' : '(opadajuce)'))
                            : ('Nazivu' + ' ' + (this.search.dir == 'asc' ? '(a-z)' : '(z-a)')));
                }
            },


            /**
             * @param order
             * @param dir
             * @param text
             */
            sort(order, dir, text) {

                this.search.order   = order;
                this.search.dir     = dir;
                this.currentSort    = text;
            },


            /**
             * Get products API
             *
             * @param url
             * @param push
             */
            getProducts(url, push = false, hideInit = false) {

                this.loading = true;

                $(".search-loader").fadeIn("fast");

                axios.get(url)

                    .then((response) => {

                        if (push) {

                            this.products.data.push(...response.data.data);

                        } else {

                            this.products.data = response.data.data;
                        }

                        if (hideInit) {

                            this.showInitialProducts = false;
                        }

                        this.products.nextPageUrl = response.data.links.next;
                    })

                    .catch((errors) => parseResponseErrors(errors))

                    .then(() => {

                        $(".search-loader").fadeOut("slow");

                        this.loading = false
                    })
            },


            /**
             * Load more products for current criteria.
             */
            loadMoreProducts() {

                this.getProducts(this.products.nextPageUrl.replace('proizvodi', 'json'), true);
            }
        },

        watch: {

            /**
             * After user stop typing change search term.
             *
             * @param newTerm
             */
            term(newTerm) {

                clearTimeout(this.termTimeout);

                this.termTimeout = setTimeout(() => {

                    this.search.term = newTerm;

                }, 500)
            },

            /**
             * After user stop typing change search term.
             *
             * @param newPrice
             */
            price(newPrice) {

                clearTimeout(this.priceTimeout);

                this.priceTimeout = setTimeout(() => {

                    this.search.price = newPrice;

                }, 500)
            },


            search: {

                handler() {

                    let current = location.href;

                    formatUrlParams(this.search);

                    if (current !== location.href) {

                        this.getProducts(location.href.replace('proizvodi', 'json'), false, true);
                    }
                },

                deep: true
            }
        }
    }

</script>